#ifndef	DOF_H_INCLUDED
#define	DOF_H_INCLUDED

#ifndef	ECB_DOF

half3	dof(float2 center, half3 sum)
{
	return	sum;
}

#else	//	ECB_DOF

#ifndef ecb_rd
	uniform half4 e_barrier;
	uniform half4 e_weights;
	uniform half4 e_kernel;
#endif

half3	dof(float2 center, half3 sum)
{

	float dep = tex2D( s_position, center ).z;
	float targetDist = tex2D( s_position, float2( 0.500001f, 0.500001f ) ).z;
	float mycof = ECB_DOF_MAXCOF;
	float myMINDIST = ECB_DOF_MINDIST;
	float myMAXDIST = ECB_DOF_MAXDIST;
	float myMAXNEAR = ECB_DOF_MAXNEAR;
	float myMINNEAR = ECB_DOF_MINNEAR;

	#ifdef ECB_DDOF

		if (targetDist < ECB_DOF_MAXDIST && targetDist > ECB_DDOF_MINDIST)
		{
			myMINDIST = targetDist + ECB_DDOF_MINDIST_ADD;
			float maxFactor = (targetDist < ECB_DDOF_MAXDIST) ? 1 : (targetDist / ECB_DDOF_MAXDIST);
			myMAXDIST = myMINDIST * ECB_DDOF_MAXDIST_FACTOR * maxFactor * 4;
		}

	#endif

	if (targetDist <= myMAXNEAR)
	{
		myMAXNEAR = targetDist;
	}

	if (dep < myMAXNEAR && dep > myMINNEAR) // && targetDist > myMAXNEAR)
	{
		dep = ( 1 - ( dep - myMINNEAR ) / ( myMAXNEAR - myMINNEAR ) ) * myMAXDIST;
		mycof = ECB_DOF_MAXCOF_NEAR;
	}

	half 	blur		= pow( saturate( ( dep - myMINDIST ) / ( myMAXDIST - myMINDIST ) ), 1 );

	half2 	scale = half2	( .5f / 1024.h, .5f / 768.h ) * mycof * blur;

	#if defined( ECB_AA ) && defined( ECB_DDOF_AIM )
		scale = half2	( ECB_DDOF_AIM_BLUR / 1024.h, ECB_DDOF_AIM_BLUR / 768.h ) * saturate( pow( ( abs( center.x - 0.5f ) + abs( center.y - 0.5f ) ), ECB_DDOF_AIM_CIRCLE ) ) * saturate(100/tex2D( s_position, center ).z);
		#undef USE_MBLUR		
	#endif

	sum = (half3) 0;

	// poisson
	static const half2 o [12] = 
	{
		float2(-0.326212f,-0.405810f)*scale,
		float2(-0.840144f,-0.073580f)*scale,
		float2(-0.695914f,0.457137f)*scale,
		float2(-0.203345f,0.620716f)*scale,
		float2(0.962340f,-0.194983f)*scale,
		float2(0.473434f,-0.480026f)*scale,
		float2(0.519456f,0.767022f)*scale,
		float2(0.185461f,-0.893124f)*scale,
		float2(0.507431f,0.064425f)*scale,
		float2(0.896420f,0.412458f)*scale,
		float2(-0.321940f,-0.932615f)*scale,
		float2(-0.791559f,-0.597710f)*scale,
	};

	// sample 
	for ( int i=0; i<12; i++ )
	{
		sum 		+= tex2D	( s_image, (float2) ( center + o[i] ) );
	}

	return 	half3	( sum / 12 );

}

#endif	//	ECB_DOF

#endif	//	DOF_H_INCLUDED
